<?php

/**
 * Fix revisioning.
 */
function course_credit_post_update_make_course_credit_revisionable4(&$sandbox) {

  $definition_update_manager = Drupal::entityDefinitionUpdateManager();
  /** @var EntityLastInstalledSchemaRepositoryInterface $last_installed_schema_repository */
  $last_installed_schema_repository = Drupal::service('entity.last_installed_schema.repository');

  $entity_type = $definition_update_manager->getEntityType('course_credit');
  $field_storage_definitions = $last_installed_schema_repository->getLastInstalledFieldStorageDefinitions('course_credit');

  // Update the entity type definition.
  $entity_keys = $entity_type->getKeys();
  $entity_keys['revision'] = 'vid';
  $entity_keys['bundle'] = 'type';
  $entity_type->set('entity_keys', $entity_keys);
  $entity_type->set('base_table', 'course_credit');
  $entity_type->set('data_table', NULL);
  $entity_type->set('revision_table', 'course_credit_revision');
  $entity_type->set('revision_data_table', NULL);
  $revision_metadata_keys = [
    'revision_default' => 'revision_default',
    'revision_user' => 'revision_user',
    'revision_created' => 'revision_created',
    'revision_log_message' => 'revision_log_message',
  ];
  $entity_type->set('revision_metadata_keys', $revision_metadata_keys);

  // Update the field storage definitions and add the new ones required by a
  // revisionable entity type.
  $field_storage_definitions['min']->setRevisionable(TRUE);
  $field_storage_definitions['max']->setRevisionable(TRUE);
  $field_storage_definitions['active']->setRevisionable(TRUE);
  $field_storage_definitions['increments']->setRevisionable(TRUE);
  $field_storage_definitions['variable']->setRevisionable(TRUE);
  $field_storage_definitions['code']->setRevisionable(TRUE);
  $field_storage_definitions['expiration_type']->setRevisionable(TRUE);
  $field_storage_definitions['expiration_date']->setRevisionable(TRUE);
  $field_storage_definitions['expiration_offset']->setRevisionable(TRUE);
  $field_storage_definitions['children']->setRevisionable(TRUE);

  $definition_update_manager->updateFieldableEntityType($entity_type, $field_storage_definitions, $sandbox);
}
