<?php

namespace Drupal\course_credit\Controller;

use Drupal;
use Drupal\Core\Access\AccessResult;
use Drupal\Core\Entity\Controller\EntityController;
use Drupal\course\Entity\Course;

class CourseCreditController extends EntityController {

  /**
   * Access callback for credit app.
   */
  public function creditAppAccess(Course $course) {
    $user = Drupal::currentUser();
    $access = FALSE;

    if ($user->isAuthenticated()) {
      if ($enrollment = $course->getEnrollment($user)) {
        $eligible = course_credit_user_credit_types($enrollment, $course, $user);
        if ($enrollment->isComplete() && !course_credit_get_credit_awarded($enrollment, $course, $user) && $eligible) {
          // User has not claimed any credit and is eligible.
          $access = TRUE;
        }
      }
    }

    return AccessResult::allowedIf($access);
  }

}
