<?php

namespace Drupal\course_credit\Plugin\migrate\source;

use Drupal\migrate_drupal\Plugin\migrate\source\d7\FieldableEntity;

/**
 * Drupal 7 course credit awarded source from database.
 *
 * @MigrateSource(
 *   id = "d7_course_credit_awarded",
 *   core = {7},
 *   source_module = "course_credit",
 *   destination_module = "course_credit"
 * )
 */
class CourseCreditAwarded extends FieldableEntity {

  /**
   * {@inheritdoc}
   */
  public function getIds() {
    $ids = [];
    $ids['ccaid']['type'] = 'integer';
    return $ids;
  }

  /**
   * {@inheritdoc}
   */
  public function query() {
    $query = $this->select('course_credit_awarded', 'cca')->fields('cca');
    return $query;
  }

  public function fields() {
    return [
      'ccaid' => 'Course credit awarded ID',
    ];
  }

}
