<?php

namespace Drupal\course_credit\Routing;

use Drupal;
use Drupal\Component\Plugin\Derivative\DeriverBase;

/**
 * Derive claim tabs based on entity references to credit mappings.
 */
class CreditLocalTasks extends DeriverBase {

  /**
   * {@inheritdoc}
   */
  public function getDerivativeDefinitions($base_plugin_definition) {
    /* @var $fields Drupal\field\Entity\FieldConfig[] */
    $entity_types = course_credit_get_entity_types();

    foreach ($entity_types ?? [] as $type) {
      $this->derivatives["course_credit.$type.claim_tab"] = [
        'title' => 'Claim credit',
        'route_name' => "course_credit.claim.$type",
        'base_route' => "entity.$type.canonical",
        'weight' => 100,
      ];
    }
    return parent::getDerivativeDefinitions($base_plugin_definition);
  }

}
