<?php

namespace Drupal\course_credit\Routing;

use Symfony\Component\Routing\Route;

/**
 * Defines dynamic routes.
 */
class CreditRoutes {

  /**
   * {@inheritdoc}
   */
  public function routes() {
    $routes = [];
    $etm = \Drupal::entityTypeManager();
    foreach (course_credit_get_entity_types() as $entity_type) {
      // Add a credit claim route based on the canonical URL.
      $template = $etm->getStorage($entity_type)->getEntityType()->getLinkTemplate('canonical');

      $tab_route = new Route($template . '/course-credit-app');
      $tab_route->setDefault('_form', '\Drupal\course_credit\Form\CourseCreditAppForm');
      $tab_route->setDefault('_title', 'Claim credit');
      $tab_route->setOption('parameters', [
        $entity_type => [
          'type' => "entity:$entity_type",
        ],
      ]);
      $tab_route->setRequirements(['_custom_access' => '\Drupal\course_credit\Controller\CourseCreditController::creditAppAccess']);
      $routes["course_credit.claim.$entity_type"] = $tab_route;
    }

    return $routes;
  }

}
